-- name: Custom 6b Luigi Voice LQ
-- incompatible:
-- description: Here's a mod with a voice for Luigi dubbed by me (\\#ff0000\\6b\\#ffffff\\). I used the codebase created by \\#ff6b91\\SMS Alfredo\\#ffffff\\ as a base (thanks to him for making it). Enjoy!!

--Define what triggers the custom voice
local function use_custom_voice(m)
    return m.character.type == CT_LUIGI --Put your condition here!
end

--How many snores the sleep-talk has, or rather, how long the sleep-talk lasts
--If you omit the sleep-talk you can ignore this
local SLEEP_TALK_SNORES = 8

--Define what actions play what voice clips
--If an action has more than one voice clip, put those clips inside a table
--CHAR_SOUND_SNORING3 requires two or three voice clips to work properly...
--but you can omit it if your character does not sleep-talk
local CUSTOM_VOICETABLE = {
    [CHAR_SOUND_ATTACKED] = {'luigi_hurt1.mp3', 'luigi_hurt2.mp3', 'luigi_hurt3.mp3', 'luigi_hurt4.mp3', 'luigi_hurt5.mp3', 'luigi_hurt6.mp3', 'luigi_hurt7.mp3', 'luigi_hurt8.mp3', 'luigi_hurt9.mp3'},
    [CHAR_SOUND_COUGHING1] = 'luigi_cough.mp3',
    [CHAR_SOUND_COUGHING2] = 'luigi_cough.mp3',
    [CHAR_SOUND_COUGHING3] = 'luigi_cough.mp3',
    [CHAR_SOUND_DOH] = {'luigi_doh.mp3', 'luigi_hurt3.mp3', 'luigi_hurt7.mp3'},
    [CHAR_SOUND_DROWNING] = {'luigi_drowning1.mp3', 'luigi_drowning2.mp3', 'luigi_drowning3.mp3', 'luigi_drowning4.mp3'},
    [CHAR_SOUND_DYING] = {'luigi_dead.mp3', 'luigi_dead2.mp3', 'luigi_dead3.mp3', 'luigi_dead4.mp3', 'luigi_dead5.mp3', 'luigi_dead6.mp3'},
    [CHAR_SOUND_EEUH] = 'luigi_takesomething.mp3',
    [CHAR_SOUND_GAME_OVER] = 'nothing.mp3',
    [CHAR_SOUND_GROUND_POUND_WAH] = {'luigi_jump_yah4.mp3', 'luigi_jump_ho5.mp3', 'luigi_ground.mp3', 'luigi_hoo.mp3', 'luigi_hoo.mp3', 'luigi_yoh.mp3'},
    [CHAR_SOUND_HAHA] = {'luigi_hoho1.mp3', 'luigi_hoho.mp3', 'luigi_hoho2.mp3', 'luigi_hohoho3.mp3', 'luigi_hoho3.mp3', 'luigi_bingo.mp3'},
    [CHAR_SOUND_HAHA_2] = {'luigi_hoho1.mp3', 'luigi_hoho.mp3', 'luigi_hoho2.mp3', 'luigi_hohoho3.mp3', 'luigi.mp3', 'luigi_hoho3.mp3', 'luigi_bingo.mp3'},
    [CHAR_SOUND_HELLO] = 'luigi_hello.mp3',
    [CHAR_SOUND_HERE_WE_GO] = {'luigi_here_we_go.mp3', 'luigi.mp3', 'luigi_letsago2.mp3', 'luigi2.mp3', 'luigi_number_one.mp3', 'luigi_bingo.mp3', 'luigi_yahoo2.mp3'},
    [CHAR_SOUND_HOOHOO] = {'luigi_heya1.mp3', 'luigi_heya2.mp3', 'luigi_heya3.mp3', 'luigi_heya4.mp3', 'luigi_heya5.mp3'},
    [CHAR_SOUND_HRMM] = 'luigi_hmm3.mp3',
    [CHAR_SOUND_IMA_TIRED] = 'luigi_tired.mp3',
    [CHAR_SOUND_LETS_A_GO] = {'luigi_letsago1.mp3', 'luigi_letsago2.mp3', 'luigi_letsago3.mp3', 'luigi3.mp3'},
    [CHAR_SOUND_MAMA_MIA] = {'luigi_mamamia.mp3', 'luigi_mamamia2.mp3', 'luigi_mamamia3.mp3', 'luigi_mamamia4.mp3', 'luigi_mamamia5.mp3', 'luigi_ohno.mp3'},
    [CHAR_SOUND_OKEY_DOKEY] = 'luigi.mp3',
    [CHAR_SOUND_ON_FIRE] = {'luigi_hurt_fire.mp3', 'luigi_hurt_fire2.mp3', 'luigi_hurt_fire3.mp3'},
    [CHAR_SOUND_OOOF] = 'luigi_hurt7.mp3',
    [CHAR_SOUND_OOOF2] = 'luigi_hurt7.mp3',
    [CHAR_SOUND_PANTING] = 'luigi_painting.mp3',
    [CHAR_SOUND_PANTING_COLD] = {'luigi_cold1.mp3', 'luigi_cold2.mp3', 'luigi_cold3.mp3'},
    [CHAR_SOUND_PRESS_START_TO_PLAY] = 'nothing.mp3',
    [CHAR_SOUND_PUNCH_HOO] = {'luigi_jump_hep.mp3', 'luigi_yo.mp3', 'luigi_jump_ho6.mp3', 'luigi_jump_hep2.mp3', 'luigi_jump_ho7.mp3'},
    [CHAR_SOUND_PUNCH_WAH] = {'luigi_jump_hah.mp3', 'luigi_jump_yah.mp3', 'luigi_jump_yah2.mp3', 'luigi_jump_ho1.mp3', 'luigi_kick.mp3'},
    [CHAR_SOUND_PUNCH_YAH] = 'luigi_jump_ho3.mp3',
    [CHAR_SOUND_SNORING1] = 'luigi_snoring1.mp3',
    [CHAR_SOUND_SNORING2] = 'luigi_snoring2.mp3',
    [CHAR_SOUND_SNORING3] = 'nothing.mp3',
    [CHAR_SOUND_SO_LONGA_BOWSER] = {'luigi_yeehee1.mp3', 'luigi_yahoo2.mp3', 'luigi_hohoho2.mp3'},
    [CHAR_SOUND_TWIRL_BOUNCE] = {'luigi_yahoo2.mp3', 'luigi_hurt4.mp3', 'luigi_yahoo2.mp3'},
    [CHAR_SOUND_UH] = {'luigi_hmm4.mp3', 'luigi_hmm2.mp3'},
    [CHAR_SOUND_UH2] = {'luigi_hmm4.mp3', 'luigi_hmm2.mp3'},
    [CHAR_SOUND_UH2_2] = {'luigi_hmm4.mp3', 'luigi_hmm2.mp3'},
    [CHAR_SOUND_WAAAOOOW] = {'luigi_fall1.mp3', 'luigi_fall2.mp3'},
    [CHAR_SOUND_WAH2] = {'luigi_jump_hah.mp3', 'luigi_jump_yah.mp3', 'luigi_jump_ho1.mp3', 'luigi_jump_yah2.mp3', 'luigi_jump_yah7.mp3', 'luigi_jump.mp3'},
    [CHAR_SOUND_WHOA] = {'luigi_wow.mp3', 'luigi_wow2.mp3', 'luigi_wow3.mp3'},
    [CHAR_SOUND_YAHOO] = {'luigi_yahoo1.mp3', 'luigi_yeehee1.mp3', 'luigi_yoho.mp3', 'luigi_yahoo3.mp3'},
    [CHAR_SOUND_YAHOO_WAHA_YIPPEE] = 'luigi_yeehee1.mp3',
    [CHAR_SOUND_YAH_WAH_HOO] = {'luigi_jump_hep.mp3', 'luigi_jump_yah3.mp3', 'luigi_jump_ho3.mp3'},
    [CHAR_SOUND_YAWNING] = 'luigi_dead2.mp3',
}

--Define the table of samples that will be used for each player
--Global so if multiple mods use this they won't create unneeded samples
--DON'T MODIFY THIS SINCE IT'S GLOBAL FOR USE BY OTHER MODS!
gCustomVoiceSamples = {}
gCustomVoiceStream = nil

--Get the player's sample, stop whatever sound
--it's playing if it doesn't match the provided sound
--DON'T MODIFY THIS SINCE IT'S GLOBAL FOR USE BY OTHER MODS!
--- @param m MarioState
function stop_custom_character_sound(m, sound)
    local voice_sample = gCustomVoiceSamples[m.playerIndex]
    if voice_sample == nil or not voice_sample.loaded then
        return
    end

    audio_sample_stop(voice_sample)
    if voice_sample.file.relativePath:match('^.+/(.+)$') == sound then
        return voice_sample
    end
    audio_sample_destroy(voice_sample)
end

--Play a custom character's sound
--DON'T MODIFY THIS SINCE IT'S GLOBAL FOR USE BY OTHER MODS!
--- @param m MarioState
function play_custom_character_sound(m, voice)
    --Get sound, if it's a table, get a random entry from it
    local sound
    if type(voice) == "table" then
        sound = voice[math.random(#voice)]
    else
        sound = voice
    end
    if sound == nil then return 0 end

    --Get current sample and stop it
    local voice_sample = stop_custom_character_sound(m, sound)

    --If the new sound isn't a string, let's assume it's
    --a number to return to the character sound hook
    if type(sound) ~= "string" then
        return sound
    end

    --Load a new sample and play it! Don't make a new one if we don't need to
    if (m.area == nil or m.area.camera == nil) and m.playerIndex == 0 then
        if gCustomVoiceStream ~= nil then
            audio_stream_stop(gCustomVoiceStream)
            audio_stream_destroy(gCustomVoiceStream)
        end
        gCustomVoiceStream = audio_stream_load(sound)
        audio_stream_play(gCustomVoiceStream, true, 1)
    else
        if voice_sample == nil then
            voice_sample = audio_sample_load(sound)
        end
        audio_sample_play(voice_sample, m.pos, 1)

        gCustomVoiceSamples[m.playerIndex] = voice_sample
    end
    return 0
end

--Main character sound hook
--This hook is freely modifiable in case you want to make any specific exceptions
--- @param m MarioState
local function custom_character_sound(m, characterSound)
    if not use_custom_voice(m) then return end
    if characterSound == CHAR_SOUND_SNORING3 then return 0 end
    if characterSound == CHAR_SOUND_HAHA and m.hurtCounter > 0 then return 0 end

    local voice = CUSTOM_VOICETABLE[characterSound]
    if voice ~= nil then
        return play_custom_character_sound(m, voice)
    end
    return 0
end
hook_event(HOOK_CHARACTER_SOUND, custom_character_sound)

--Snoring logic for CHAR_SOUND_SNORING3 since we have to loop it manually
--This code won't activate on the Japanese version, due to MARIO_MARIO_SOUND_PLAYED not being set
local SNORE3_TABLE = CUSTOM_VOICETABLE[CHAR_SOUND_SNORING3]
local STARTING_SNORE = 46
local SLEEP_TALK_START = STARTING_SNORE + 49
local SLEEP_TALK_END = SLEEP_TALK_START + SLEEP_TALK_SNORES

--Main hook for snoring
--- @param m MarioState
local function custom_character_snore(m)
    if not use_custom_voice(m) then return end

    --Stop the snoring!
    if m.action ~= ACT_SLEEPING then
        if m.isSnoring > 0 then
            stop_custom_character_sound(m)
        end
        return

    --You're not in deep snoring
    elseif not (m.actionState == 2 and (m.flags & MARIO_MARIO_SOUND_PLAYED) ~= 0) then
        return
    end

    local animFrame = m.marioObj.header.gfx.animInfo.animFrame

    --Behavior for CHAR_SOUND_SNORING3
    if SNORE3_TABLE ~= nil and #SNORE3_TABLE >= 2 then
        --Exhale sound
        if animFrame == 2 and m.actionTimer < SLEEP_TALK_START then
            play_custom_character_sound(m, SNORE3_TABLE[2])

        --Inhale sound
        elseif animFrame == 25 then
            
            --Count up snores
            if #SNORE3_TABLE >= 3 then
                m.actionTimer = m.actionTimer + 1

                --End sleep-talk
                if m.actionTimer >= SLEEP_TALK_END then
                    m.actionTimer = STARTING_SNORE
                end
    
                --Enough snores? Start sleep-talk
                if m.actionTimer == SLEEP_TALK_START then
                    play_custom_character_sound(m, SNORE3_TABLE[3])
                
                --Regular snoring
                elseif m.actionTimer < SLEEP_TALK_START then
                    play_custom_character_sound(m, SNORE3_TABLE[1])
                end
            
            --Definitely regular snoring
            else
                play_custom_character_sound(m, SNORE3_TABLE[1])
            end
        end

    --No CHAR_SOUND_SNORING3, just use regular snoring
    elseif animFrame == 2 then
        play_character_sound(m, CHAR_SOUND_SNORING2)

    elseif animFrame == 25 then
        play_character_sound(m, CHAR_SOUND_SNORING1)
    end
end
hook_event(HOOK_MARIO_UPDATE, custom_character_snore)